# 快捷命令 V1.5.0

## 简介

自定义可以在`uTools`中快速执行的命令或脚本

### 更新

#### v1.5.0

##### 功能更新

- 新增`通过uTools呼出前的窗口匹配`的模式，现在可以快速编写一个应用到当前活动窗口的脚本
- 现在可以分别通过`关键字`,`主输入框正则匹配`,`活动窗口匹配`三种方式来调用自定义的脚本

![Snipaste_2020-04-10_02-50-18.png](https://user-gold-cdn.xitu.io/2020/4/10/1716049625b73321?w=804&h=660&f=png&s=59600)

- 新增一个特殊变量`当前窗口信息`，输出`json`格式的窗口相关信息，将原先的特殊变量`用户名`改为`本机唯一ID`，方便针对不同电脑编写脚本，两个变量均通过官方API获取
- 弃用原先模拟按键的方式，获取资源管理器路径、选中文件、浏览器地址均借助官方API
- 新增`发送系统通知`的输出模式 By [imxiny](https://github.com/imxiny)
- 新增`在终端显示`的输出模式, 用以解决脚本需要显示动态输出的问题, 如 curl 命令 [issue](https://github.com/fofolee/uTools-QuickerCommand/issues/3)
- 上传一些命令至仓库的`CommandCollections`文件夹，用以作为编写命令的样例，同时大家可以提交PR丰富这个命令库

##### BUG 修复

- 修复 php 无法输入 <? 问题，修复MacOS环境变量问题，修复脚本不能带参数问题 By [dofy](https://github.com/dofy)
- 修复中文乱码问题
- 修复当使用子输入框时，会多次触发脚本的问题 [issue](https://github.com/fofolee/uTools-QuickerCommand/issues/5)
- 修复当使用多行批处理脚本时，执行会报错的问题，该问题源于之前插件保存的批处理脚本的换行符是`LF`, windows 无法识别 [issue](https://yuanliao.info/d/424/70)

##### 用户体验

- 获取选中文本，以及输出方式为发送到活动窗口时不再覆盖用户剪贴板

##### 催更

- 之前了解到官方将出自动化插件，所以也有较长时间没有更新，在此以更催更

#### v1.1.0

- 新增支持获取子输入框变量，感谢@ghostbody
- 支持自定义解释器的路径

#### v1.0.0

- 上架 uTools 商店,去掉插件自带更新
- 精简了插件大小
- 可以自定义语言

#### v0.0.2

- 修复uTools更新后进入插件空白的BUG
- 添加Linux支持
- 修复导入BUG
- 修复说明为空时无法启用命令的BUG
- 添加全部导出和全部删除的功能

## 功能

#### 快速启动

可以配置一些常用的命令，比如`回收站` `查看网络连接`之类

![UTOOLS1556854200416.png](https://i.loli.net/2019/05/03/5ccbb5bb2c7d5.png)

![UTOOLS1556779310377.png](https://i.loli.net/2019/05/02/5cca91329a525.png)

![UTOOLS1556779348048.png](https://i.loli.net/2019/05/02/5cca9155a2244.png)

![UTOOLS1556779660316.png](https://i.loli.net/2019/05/02/5cca928f51905.png)

配合`uTools`的全局功能快捷键，可以达到一键启动的功能

#### 常用脚本

如果为了一个小功能，就去编写一个插件，成本太高，本插件可以利用本地的脚本环境快速实现一些小功能。比如`base64转图片`等

![UTOOLS1556779835126.png](https://i.loli.net/2019/05/02/5cca933de1883.png)

目前可以添加以下类型的脚本，但要注意的是**本插件未封装任何运行环境，需要本机安装了环境才能执行相应的脚本**

![UTOOLS1556779901749.png](https://i.loli.net/2019/05/02/5cca938100c91.png)

同时，本插件可以作为一个便捷的脚本仓库，因为所有的脚本都是多设备自动同步的，无须另外存储在硬盘中

#### 输出处理

如果脚本有输出，则可以对输出内容做如下处理

- 忽略输出
- 显示纯文本输出 (不解析 html 内容)
- 显示html格式的输出 (可以进一步编写简单的 GUI 界面)
- 复制到剪贴板
- 发送到活动窗口（可以实现类似代码片段、常用短语之类的功能）
- 发送到系统通知
- 在终端中显示

#### 插值变量

如果你仔细看了上面例子中的脚本，一定会发现很多脚本里都有`{{}}`格式的变量

本插件内置了一些特殊的插值变量，可以获取一些特殊的值，能够加入到插件里的任意脚本中

全模式可用

- `{{isWin}}` 是否是window系统
- `{{LocalId}}`本机唯一ID
- `{{BrowserUrl}}` 浏览器的当前链接
- `{{ClipText}}` 获取剪贴板的文本
- `{{SelectText}}` 获取选中的文本
- `{{subinput}}`获取子输入框的文本

窗口模式可用

- `{{pwd}}` 资源管理器或访达的当前目录
- `{{SelectFile}}` 获取选中的文件
- `{{WindowInfo}}`当前窗口信息

正则匹配模式可用

- `{{input}} ` 获取uTools主输入框的文本

插值使用示例

![UTOOLS1586459651493.png](https://user-gold-cdn.xitu.io/2020/4/10/171605d2dcc092fd?w=804&h=660&f=png&s=36561)

![UTOOLS1586459708623.png](https://user-gold-cdn.xitu.io/2020/4/10/171605e0cf962dad?w=804&h=660&f=png&s=29783)

## 安装方法

插件中心进行安装

[项目地址](https://github.com/fofolee/uTools-QuickerCommand)

[插件发布页](https://yuanliao.info/d/424)

## 关键字

`快捷命令` `QuickCommand`